
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayList;

// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
import java.util.Random;
// #[regen=yes,id=DCE.202644E6-131F-73A1-C556-833D113C5AB4]
// </editor-fold> 
public class Partida {

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.45B348C8-D063-821F-673E-A9552B93ACCE]
    // </editor-fold> 
    private int NumeroJugadores = 0;
    private boolean finalizar=false;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.91C21E03-CA03-C9B6-942C-62A6E087CF98]
    // </editor-fold> 
    private ArrayList<Jugador> ListaJugador = null;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.53DD0E24-A874-9011-6C59-6B84F6C6BAAE]
    // </editor-fold> 
    private Tablero mTablero = new Tablero();

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.5C57A7A5-E5D6-6B68-DB62-7B813F236AFB]
    // </editor-fold> 
    public Partida () throws java.io.IOException {
        //en el constructor creamos los jugadores y llamamos a jugar para gestionar los turno
        System.out.println("Se ha creado una partida");
        //Creación del flujo para leer datos
        InputStreamReader isr = new InputStreamReader(System.in);
        BufferedReader br = new BufferedReader(isr);
        boolean error = false;
        
        do
        {
            if( error )
            {
                System.out.println("El numero de jugadores debe estar en [2 - 6].");
                error = false;
            }
            System.out.print("Introduce el numero de jugadores: ");
            String texto1 = br.readLine();
            NumeroJugadores = Integer.parseInt(texto1);
            System.out.println("Numero de jugadores: " + NumeroJugadores);
            
            if( NumeroJugadores < 2 || NumeroJugadores > 6)
                error = true;
            
        }while (NumeroJugadores < 2 || NumeroJugadores > 6);
    
    
        //Inicializamos el array con los jugadores al numero de jugadores introducidos
        ListaJugador = new ArrayList(NumeroJugadores);
        
        int ejerc_iniciales = 0;
        switch(NumeroJugadores)
        {

            case 2:
                ejerc_iniciales = 45;
                break;
            case 3:
                ejerc_iniciales=35;
                break;
            case 4:
                ejerc_iniciales=30;
                break;
            case 5:
                ejerc_iniciales=25;
                break;
            case 6:
                ejerc_iniciales=20;
                break;
        }
        //creamos los jugadores
        for (int i=1;i<=NumeroJugadores;i++)
        {
           System.out.print("Nombre del jugador " + i + ": ");
           String texto1=br.readLine(); // pedimos los nombres por teclado           
           ListaJugador.add(new Jugador(texto1,ejerc_iniciales));
        }
        
        repartirTerritorios();
        repartirEjercito();
        Jugar(); // comenzamos la partida
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.3A97B43A-2109-0884-F565-3840AF227B5F]
    // </editor-fold> 
    public void Jugar () throws java.io.IOException {
        //en jugar se lleva la gestion de los turnos y se envia el control
        //de decisiones a el jugador que tiene el turno 
      int turnojugador=0;
      int seleccion=0;
      
      InputStreamReader isr=new InputStreamReader(System.in);
      BufferedReader br=new BufferedReader(isr); 
       do{ //en este primer do se ejecuta la partida hasta que un jugador elige
           //la opcion de terminar la partida
        
          do{//en este segundo do, si el jugador sigue manteniendo el turno 
              //mientras no eliga la opcion finalizar partida o finalizar turno
          
          System.out.print("Turno de jugador: ");
          System.out.println(ListaJugador.get(turnojugador).getNombreJugador());
          seleccion = ListaJugador.get(turnojugador).Accion();
          if (seleccion==4)
          {
                FinalizarPartida();
          }
          //la opcion 6 es para mirar los paises y continentes
          if (seleccion==6){
              
              
             ArrayList <Continente> Nombres = mTablero.getContinente();                
                System.out.println("Continente: " + Nombres.get(0).getNombreContinente());
                for (int i=0;i<7;i++){
                    System.out.println("Territorio: "+ Nombres.get(0).getTerritorio().get(i).getNombreTerritorio() + "Propietario: " + Nombres.get(0).getTerritorio().get(i).getPropietario().getNombreJugador());
                }
                System.out.println("Continente: " + Nombres.get(1).getNombreContinente());
                for (int i=0;i<6;i++){
                    System.out.println("Territorio: "+ Nombres.get(1).getTerritorio().get(i).getNombreTerritorio()+ "Propietario: " + Nombres.get(1).getTerritorio().get(i).getPropietario().getNombreJugador());
                }
                System.out.println("Continente: " + Nombres.get(2).getNombreContinente());
                for (int i=0;i<12;i++){
                    System.out.println("Territorio: "+ Nombres.get(2).getTerritorio().get(i).getNombreTerritorio()+ "Propietario: " + Nombres.get(2).getTerritorio().get(i).getPropietario().getNombreJugador());
                }
                System.out.println("Continente: " + Nombres.get(3).getNombreContinente());
                for (int i=0;i<4;i++){
                    System.out.println("Territorio: "+ Nombres.get(3).getTerritorio().get(i).getNombreTerritorio()+ "Propietario: " + Nombres.get(3).getTerritorio().get(i).getPropietario().getNombreJugador());
                }
                System.out.println("Continente: " + Nombres.get(4).getNombreContinente());
                for (int i=0;i<9;i++){
                    System.out.println("Territorio: "+ Nombres.get(4).getTerritorio().get(i).getNombreTerritorio()+ "Propietario: " + Nombres.get(4).getTerritorio().get(i).getPropietario().getNombreJugador());
                }
                System.out.println("Continente: " + Nombres.get(5).getNombreContinente());
                for (int i=0;i<4;i++){
                    System.out.println("Territorio: "+ Nombres.get(5).getTerritorio().get(i).getNombreTerritorio()+ "Propietario: " + Nombres.get(5).getTerritorio().get(i).getPropietario().getNombreJugador());
                }
             
             }
           
        }while (seleccion!=2 && finalizar==false);   
         
      //este if cuando llega al final de jugadores, volvemos a empezar por el primero
        if (turnojugador<NumeroJugadores-1)
            turnojugador++;
        else
            turnojugador=0;
        System.out.println("Cambio de Turno.");
       }while(!finalizar);
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.3F5B2AC9-C563-07BC-3841-BAF79ED50145]
    // </editor-fold> 
    public ArrayList<Jugador> getJugador () {
        return null;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.1A9F203C-96B3-7D24-8AFB-BF92C3F1C2EF]
    // </editor-fold> 
    public void setJugador (ArrayList<Jugador> val) {
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.317252FA-B58B-F9F3-B60E-13374DDE485F]
    // </editor-fold> 
    public Tablero getTablero () {
        return null;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.8A0754D5-8421-946C-5237-DEFDB3872F5E]
    // </editor-fold> 
    public void setTablero (Tablero val) {
    }
    
    public int getNumeroJugadores(){
    return NumeroJugadores;
    }

    private void FinalizarPartida() {
        System.out.println("Finalizando Partida");
        finalizar=true;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.5F6DA05D-39C5-70AB-0853-DC70C1CC2682]
    // </editor-fold> 
    public void repartirEjercito () {
    //se reparte 1 ejercito disponible por el jugador en 1 de sus territorios
    //sucesivamente hasta que no tenga ejercitos disponibles
    //se pasa al siguiente jugador para que reparta sus territorios
    for(int i=0;i<NumeroJugadores;i++)
           {
                  
               while(ListaJugador.get(i).getNumEjerAsig()>0)
               {
                   for(int j=0;j<ListaJugador.get(i).getTerritorio().size();j++)
                   {
                       //obtengo el numeo de ejercitos que le quedan al jugador por colocar, para decrementar su numero
                        int numEjerAsg = ListaJugador.get(i).getNumEjerAsig();
                        if (numEjerAsg==0)
                        {
                            j=ListaJugador.get(i).getTerritorio().size();
                        }
                        else
                        {
                            ListaJugador.get(i).setNumEjerAsig(numEjerAsg-1);
                            //obtengo el numero de ejercitos del territorio donde quiero ponerlos
                            int numEjerAnt= ListaJugador.get(i).getTerritorio().get(j).getNumEjer() ;
                            ListaJugador.get(i).getTerritorio().get(j).setNumEjer(numEjerAnt+1);
                        }
    
                        
                   }
               }
           
           }
    }

    private void repartirTerritorios() {
        //se reparten los territorios aleatoriamente entre todos los jugadores
        int repartidos=0;
        boolean correcto= false;

        do
        {
            for (int i=0;i<NumeroJugadores;i++)
            {
                do
                {
                    //escogemos un continente al azar
                    Random rnd=new Random();
                    int ContinenteAleatorio,TerritorioAleatorio;
                    ContinenteAleatorio=rnd.nextInt(6);
                    
                    Continente ConAle = mTablero.getContinente().get(ContinenteAleatorio);
                    //escogemos un territorio al azar                    
                    TerritorioAleatorio=rnd.nextInt(ConAle.getnumTerritorios()); 
                    if (ConAle.getTerritorio().get(TerritorioAleatorio).getPropietario() == null)
                    {
                        ConAle.getTerritorio().get(TerritorioAleatorio).setPropietario(ListaJugador.get(i));
                        ListaJugador.get(i).anadirTerritorioPropio(ConAle.getTerritorio().get(TerritorioAleatorio));
                        
                        correcto=true;
                    }
                    else
                    {
                        correcto=false;
                    }
                }while(!correcto);        
             repartidos++;
            }
        
        }while(repartidos < 42);
        
    }

}

