
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList; 
import java.util.Collections;

public class Jugador {

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.7506432B-D3BD-AECB-DA52-14D0A9AC2BCF]
    // </editor-fold> 
    private ArrayList<Dado> mDadoDef;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.FC41C58C-48A8-3AE1-5DCF-FE9A34168DEF]
    // </editor-fold> 
    private ArrayList<Dado> mDadoAtq;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.09B9CEC6-BA67-B7C4-6EAC-69BE3D1AE5D5]
    // </editor-fold> 
    private String NombreJugador;
    private int NumEjerAsig;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.66348826-88A9-56FC-3717-865C2970BDC7]
    // </editor-fold> 
    private ArrayList<CartaTerritorio> mCartaTerritorio;
    private ArrayList<Territorio> TerritoriosPropios;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.881B6F93-7C57-67DC-8AC6-8BB350927BF5]
    // </editor-fold> 
    private CartaMision mCartaMision;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.3FC3BED4-C731-F1FE-3D39-C386D5A07090]
    // </editor-fold> 
    public Jugador (String Nombre, int num_ejerc) {
        NombreJugador = Nombre;
        NumEjerAsig = num_ejerc;
        mCartaTerritorio = new ArrayList(6); // como maximo un jugador tendra 6 cartas
        TerritoriosPropios = new ArrayList(42); // como maximo un jugador podrá tener 42 territorios
        mDadoAtq = new ArrayList (3); // 3 dados para el ataque
        mDadoDef = new ArrayList(2); // 2 dados para la defensa  
    }
    
    public int Accion () throws IOException {
    int opcion=0;
    do{
        System.out.println("¿Que opcion desea hacer?");
        //
        System.out.println("1 Atacar");
        System.out.println("2 Terminar Turno");
        System.out.println("3 Transferir Ejercitos");
        System.out.println("4 Finalizar Partida");
        System.out.println("5 Ver cartas");
        System.out.println("6 Ver Continentes y Territorios");
        System.out.print("Selecciona: ");
        InputStreamReader isr = new InputStreamReader(System.in);
        BufferedReader br = new BufferedReader(isr);
        String texto1 = br.readLine();
        opcion = Integer.parseInt(texto1);
        switch (opcion)
          {
              case 1: 
                  try
                  {
                      Atacar();
                  }catch(IOException e)
                  {
                      e.getMessage();
                  }
                      break;
              case 3: Transferir();
                      break;
              case 5: VerCartas();
                      break;
        }
        
    }while (opcion<1 && opcion >5);
    
    
    return opcion;
    
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.284559D2-132A-FA5F-78E6-D66024230D41]
    // </editor-fold> 
    public void setNombreJugador (String Nombre) {
        NombreJugador = Nombre;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.99FBBD46-9631-1BA0-7A14-C3CF7BF9A181]
    // </editor-fold> 
    public String getNombreJugador () {
        return NombreJugador;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.DF592639-CFEB-30E8-F414-0659D32EF7C0]
    // </editor-fold> 
    public CartaMision getCartaMision () {
        return mCartaMision;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.1F7E3895-61D1-BC66-3488-CF3C5073C03A]
    // </editor-fold> 
    public void setCartaMision (CartaMision val) {
        mCartaMision = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.2B7667C4-73DC-CBBD-BF23-41F05F00D839]
    // </editor-fold> 
    public ArrayList<CartaTerritorio> getCartaTerritorio () {
        return mCartaTerritorio;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.11611204-A97C-7FBC-FC42-73D3BC0C57C3]
    // </editor-fold> 
    public void setCartaTerritorio (ArrayList<CartaTerritorio> val) {
        mCartaTerritorio = val;
    }
    public void setTerritorio (ArrayList<Territorio> val){
        TerritoriosPropios = val;
    }
    public ArrayList<Territorio> getTerritorio(){
        return TerritoriosPropios;
    }
    
    public void ubicarTropas(){
    }
    public void Atacar() throws IOException{
        boolean territorioAtqPropio=false;
        int territorioAtq;
        if(TerritoriosPropios.size() > 0) // para atacar al menos debemos tener 1 territorio
       {
          System.out.println("Jugador " + NombreJugador + " esta atacando");
          VerTerritorios();
          System.out.print("Seleccione uno de sus territorios: ");
          InputStreamReader isr = new InputStreamReader(System.in);
          BufferedReader br = new BufferedReader(isr);
          String seleccion = br.readLine();
          int territorioMio = Integer.parseInt(seleccion);
          territorioMio = territorioMio - 1; // en el array es una posicion menos
       
          //MOSTRAMOS LOS TERRITORIOS CONTIGUOS------
          ArrayList<Territorio> Adyacentes = TerritoriosPropios.get(territorioMio).getAdyacentes();
          do
          {
                System.out.println("Territorio a atacar.");
                for(int i=0; i<Adyacentes.size(); i++)
                {
                     System.out.println(""+(i+1)+") "+ Adyacentes.get(i).getNombreTerritorio() + " Ejercitos: " + Adyacentes.get(i).getNumEjer());
                }
                System.out.print("Seleccione el territorio a atacar, 0 para salir: ");
                InputStreamReader isr2 = new InputStreamReader(System.in);
                BufferedReader br2 = new BufferedReader(isr2);
                String seleccion2 = br2.readLine();
                territorioAtq = Integer.parseInt(seleccion2);
                if (territorioAtq==0)
                {
                    Accion();
                }
                territorioAtq = territorioAtq - 1; // en el array es una posicion anterior
                if  (TerritoriosPropios.contains(Adyacentes.get(territorioAtq)))
                    territorioAtqPropio=true;
                else
                    territorioAtqPropio=false;                    
                
          }while(territorioAtqPropio); 
          int numDadosAtq = TerritoriosPropios.get(territorioMio).getNumEjer();
       switch(numDadosAtq)
       {
           case 1:
               System.out.println("No se puede atacar con 1 solo ejercito.");
               numDadosAtq = 0; // no puede atacar
               break;
           case 2:
               System.out.println("Atacara con 1 dado.");
               numDadosAtq = 1;
               break;
           case 3:
               System.out.println("Atacara con 2 dados.");
               numDadosAtq = 2;
               break;
           default: // si hay más de 3 (no puede haber 0 ejercitos)
               System.out.println("Atacara con 3 dados.");
               numDadosAtq = 3;
               break;
       }
       System.out.println("Dados defensa");
       int numDadosDef = Adyacentes.get(territorioAtq).getNumEjer();
       switch(numDadosDef)
       {
           case '1':
               System.out.println("Se defiende con 1 dado.");
               numDadosDef = 1;
               break;
           default:
               System.out.println("Se defiende con 2 dados.");
               numDadosDef = 2;
               break;
       }
       
       if (numDadosAtq !=0)//para poder atacar el numero de dados del atacante tiene que ser mayor que 0
       {
       
       for(int i = 0; i<numDadosAtq; i++){
            mDadoAtq.add(i, new Dado());
            tirarDado(mDadoAtq.get(i));
       }  
       for(int i= 0; i<numDadosDef; i++){
            mDadoDef.add(i, new Dado());
           tirarDado(mDadoDef.get(i));
       }
       
       //Hemos creado los dados segun los ejercitos y lo hemos lanzado
       //posteriormente vamos a ordenar los dados para su comparacion
       //y ver asi quien gana
       

       //metodo para ordenar los valores de los dados
       Collections.sort(mDadoAtq);
       Collections.sort(mDadoDef);
       
       for(int i = 0; i<numDadosAtq; i++){
       System.out.println("Dado ataque numero " + (i+1) + " valor " + mDadoAtq.get(i).getValorCara());
       }
       for(int i = 0; i<numDadosDef; i++){
       System.out.println("Dado defensa numero " + (i+1) + " valor " + mDadoDef.get(i).getValorCara());
       }
       
       for (int i=0; i<numDadosDef;i++){
         if(mDadoAtq.get(i).getValorCara() > mDadoDef.get(i).getValorCara())
              {
                  int ejercitosActuales = Adyacentes.get(territorioAtq).getNumEjer();
                  Adyacentes.get(territorioAtq).setNumEjer(ejercitosActuales-1);
              }
          else if (mDadoAtq.get(0).getValorCara() < mDadoDef.get(0).getValorCara())
              {
                  int ejercitosActuales = TerritoriosPropios.get(territorioMio).getNumEjer();
                  TerritoriosPropios.get(territorioMio).setNumEjer(ejercitosActuales-1);
              }
           
       }
       
       }
       
//       if(numDadosAtq == numDadosDef) // caso (1 a 1) o (2 a 2)
//       {
//          if(numDadosAtq == 1) // numDadosDef tambien vale 1
//          {
//              if(mDadoAtq.get(0).getValorCara() > mDadoDef.get(0).getValorCara())
//              {
//                  int ejercitosActuales = Adyacentes.get(territorioAtq).getNumEjer();
//                  Adyacentes.get(territorioAtq).setNumEjer(ejercitosActuales-1);
//              }
//              else if (mDadoAtq.get(0).getValorCara() < mDadoDef.get(0).getValorCara())
//              {
//                  int ejercitosActuales = TerritoriosPropios.get(territorioMio).getNumEjer();
//                  TerritoriosPropios.get(territorioMio).setNumEjer(ejercitosActuales-1);
//              }
//              // si son iguales no se hace nada...
//          }
//          else // numDadosAtq y Def = 2
//          {
//             int mayorAtq = Integer.MIN_VALUE;
//             int menorAtq = Integer.MIN_VALUE;
//             int mayorDef = Integer.MIN_VALUE;
//             int menorDef = Integer.MIN_VALUE;
//             
//             if( mDadoAtq.get(0).getValorCara() >= mDadoAtq.get(1).getValorCara())
//             {
//                 mayorAtq = mDadoAtq.get(0).getValorCara();
//                 menorAtq = mDadoAtq.get(1).getValorCara();
//             }
//             else
//             {
//                 mayorAtq = mDadoAtq.get(1).getValorCara();
//                 menorAtq = mDadoAtq.get(1).getValorCara();
//             }
//             
//             if( mDadoDef.get(0).getValorCara() >= mDadoDef.get(1).getValorCara())
//             {
//                 mayorDef = mDadoDef.get(0).getValorCara();
//                 menorDef = mDadoDef.get(1).getValorCara();
//             }
//             else
//             {
//                 mayorDef = mDadoDef.get(1).getValorCara();
//                 menorDef = mDadoDef.get(0).getValorCara();
//             }
//             if(mayorAtq > mayorDef)
//             {
//                int ejercitosActuales = Adyacentes.get(territorioAtq).getNumEjer();
//                Adyacentes.get(territorioAtq).setNumEjer(ejercitosActuales-1);
//             }
//             else if (mayorAtq < mayorDef)
//             {
//               int ejercitosActuales = TerritoriosPropios.get(territorioMio).getNumEjer();
//               TerritoriosPropios.get(territorioMio).setNumEjer(ejercitosActuales-1);
//             }
//             
//             //Si son iguales no se hace nada
//             
//             if(menorAtq > menorDef)
//             {
//                int ejercitosActuales = Adyacentes.get(territorioAtq).getNumEjer();
//                Adyacentes.get(territorioAtq).setNumEjer(ejercitosActuales-1);
//             }
//             else if (menorAtq < menorDef)
//             {
//               int ejercitosActuales = TerritoriosPropios.get(territorioMio).getNumEjer();
//               TerritoriosPropios.get(territorioMio).setNumEjer(ejercitosActuales-1);
//             }
//             
//          }
//       }
//       else if (numDadosAtq < numDadosDef) // caso (1 a 2)
//       {
//           
//           int valorAtq = mDadoAtq.get(0).getValorCara();
//           int valorDef = Integer.MIN_VALUE;
//           
//           if(mDadoDef.get(0).getValorCara() >= mDadoDef.get(1).getValorCara())
//           {
//              valorDef = mDadoDef.get(0).getValorCara();
//           }
//           else
//           {
//              valorDef = mDadoDef.get(1).getValorCara();
//           }
//           
//           if (valorAtq > valorDef)
//           {
//            int ejercitosActuales = Adyacentes.get(territorioAtq).getNumEjer();
//            Adyacentes.get(territorioAtq).setNumEjer(ejercitosActuales-1);   
//           }
//           
//           else if (valorAtq < valorDef)
//           {
//              int ejercitosActuales = TerritoriosPropios.get(territorioMio).getNumEjer();
//              TerritoriosPropios.get(territorioMio).setNumEjer(ejercitosActuales-1);
//           }
//           
//           //Si son iguales no se hace nada
//           
//       }
//       else // numDadosAtq > numDadosDef --> caso (2 a 1) o (3 a 2)
//       {
//           if(numDadosAtq == 2) // caso 2 a 1
//           {
//               int valorDef = mDadoDef.get(0).getValorCara();
//               int valorAtq = Integer.MIN_VALUE;
//               
//               if (mDadoAtq.get(0).getValorCara() >= mDadoDef.get(1).getValorCara())
//               {
//               valorAtq = mDadoAtq.get(0).getValorCara();
//               }
//               else 
//               {
//               valorAtq = mDadoAtq.get(1).getValorCara();
//               }
//               
//               if (valorAtq > valorDef)
//               {
//               int ejercitosActuales = Adyacentes.get(territorioAtq).getNumEjer();
//                Adyacentes.get(territorioAtq).setNumEjer(ejercitosActuales-1);
//               }
//               
//               else if (valorAtq < valorDef)
//               {
//                int ejercitosActuales = TerritoriosPropios.get(territorioMio).getNumEjer();
//                TerritoriosPropios.get(territorioMio).setNumEjer(ejercitosActuales-1);   
//               }
//               // si son iguales no pasa nada
//           }
//           
//           else if(numDadosAtq == 3) //caso 3 a 2
//           {
//               int mayorAtq = Integer.MIN_VALUE;
//               int menorAtq = Integer.MIN_VALUE;
//               int mayorDef = Integer.MIN_VALUE;
//               int menorDef = Integer.MIN_VALUE;
//               
//               if ((mDadoAtq.get(0).getValorCara() >= mDadoAtq.get(1).getValorCara()) && (mDadoAtq.get(0).getValorCara() >= mDadoAtq.get(2).getValorCara()))
//               {
//                  mayorAtq= mDadoAtq.get(0).getValorCara();
//               }
//               else if ((mDadoAtq.get(1).getValorCara() >= mDadoAtq.get(0).getValorCara()) && (mDadoAtq.get(1).getValorCara() >= mDadoAtq.get(2).getValorCara()))
//               {
//               mayorAtq= mDadoAtq.get(1).getValorCara();
//               }
//               else if ((mDadoAtq.get(2).getValorCara() >= mDadoAtq.get(0).getValorCara()) && (mDadoAtq.get(2).getValorCara() >= mDadoAtq.get(1).getValorCara()))
//               {
//               mayorAtq= mDadoAtq.get(2).getValorCara();
//               }
//               
//               
//               if ((mDadoAtq.get(0).getValorCara() <= mDadoAtq.get(1).getValorCara()) && (mDadoAtq.get(0).getValorCara() <= mDadoAtq.get(2).getValorCara()))
//               {
//               menorAtq= mDadoAtq.get(0).getValorCara();
//               }
//               else if ((mDadoAtq.get(1).getValorCara() <= mDadoAtq.get(0).getValorCara()) && (mDadoAtq.get(1).getValorCara() <= mDadoAtq.get(2).getValorCara()))
//               {
//               menorAtq= mDadoAtq.get(1).getValorCara();
//               }
//               else if ((mDadoAtq.get(2).getValorCara() <= mDadoAtq.get(0).getValorCara()) && (mDadoAtq.get(2).getValorCara() <= mDadoAtq.get(1).getValorCara()))
//               {
//               menorAtq= mDadoAtq.get(2).getValorCara();
//               }
//               
//               if (mDadoDef.get(0).getValorCara() >= mDadoDef.get(1).getValorCara())
//               {
//               mayorDef= mDadoDef.get(0).getValorCara();
//               }
//               else 
//               {
//               mayorDef= mDadoDef.get(1).getValorCara();
//               }
//               
//               if (mDadoDef.get(0).getValorCara() <= mDadoDef.get(1).getValorCara())
//               {
//               menorDef= mDadoDef.get(0).getValorCara();
//               }
//               else 
//               {
//               menorDef= mDadoDef.get(1).getValorCara();
//               }
//               
//               if(mayorAtq > mayorDef)
//             {
//                int ejercitosActuales = Adyacentes.get(territorioAtq).getNumEjer();
//                Adyacentes.get(territorioAtq).setNumEjer(ejercitosActuales-1);
//             }
//             else if (mayorAtq < mayorDef)
//             {
//               int ejercitosActuales = TerritoriosPropios.get(territorioMio).getNumEjer();
//               TerritoriosPropios.get(territorioMio).setNumEjer(ejercitosActuales-1);
//             }
//           
//           }
//           
//       }
//       } 
       }
       else
           System.out.println("Usted debe tener al menos un territorio para atacar.");
           
        //borramos el array de dados para que no de problemas al realizar las ordenaciones
        mDadoDef.removeAll(mDadoDef);
        mDadoAtq.removeAll(mDadoAtq);
    }
       
    public void anadirTerritorioPropio(Territorio t)
    {
       TerritoriosPropios.add(t); // añade un territorio
    }
    public void eliminarTerritorioPropio(Territorio t)
    {
       TerritoriosPropios.remove(t); // borra un territorio
    }
    
    public void Transferir(){
    System.out.println("Jugador " + NombreJugador + " esta transfiriendo ejercitos");
    
    }
    public void VerCartas(){
    System.out.println("Jugador " + NombreJugador + " esta viendo Cartas");
    }

    public void VerTerritorios() {
        System.out.println("Num Territorios = ");
        int nTerritorios = TerritoriosPropios.size(); // tenemos el numero de territorios del usuario
        if(nTerritorios > 0) // implica que tenemos al menos 1 territorio.
        {
           
           System.out.println("Usted tiene " + nTerritorios + " territorios:");
           for(int i = 0; i<nTerritorios; i++)
           {
              System.out.println("" + (i+1) + ") " + TerritoriosPropios.get(i).getNombreTerritorio() + " Ejercitos: " + TerritoriosPropios.get(i).getNumEjer());
           }
        }
        else
           System.out.println("Usted no tiene ningun territorio aun.");
    }
    
    public void tirarDado(Dado d)
    {
        d.LanzarDado();
        
    }
    public int getNumEjerAsig()
    {
        return NumEjerAsig;
    
    }
    public void setNumEjerAsig(int val)
    {
        NumEjerAsig = val;
    }
}

